// DebugUnit.h : implementation file
//
// Copyright(C) 2009 ubisys technologies GmbH, Duesseldorf, Germany.
// All rights reserved.
//
// www.ubisys.de
// support@ubisys.de
//
// THIS SOURCE CODE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
//
// IN NO EVENT SHALL UBISYS TECHNOLOGIES BE LIABLE FOR ANY CLAIM, DAMAGES OR
// OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, 
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOURCE CODE OR THE USE OR
// OTHER DEALINGS IN THE SOURCE CODE.
//
// Part of the ubisys(R) 13.56 MHz RFID USB stick demo application
//
// TRACE and ASSERT macros for debugging

#ifdef _DEBUG
#define TRACE0(arg0) OutputDebugStringEx(arg0)
#define TRACE1(arg0, arg1) OutputDebugStringEx(arg0, arg1)
#define TRACE2(arg0, arg1, arg2) OutputDebugStringEx(arg0, arg1, arg2)
#define TRACE3(arg0, arg1, arg2, arg3) OutputDebugStringEx(arg0, arg1, arg2, arg3)
#define TRACE4(arg0, arg1, arg2, arg3, arg4) OutputDebugStringEx(arg0, arg1, arg2, arg3, arg4)
#define TRACE5(arg0, arg1, arg2, arg3, arg4, arg5) OutputDebugStringEx(arg0, arg1, arg2, arg3, arg4, arg5)
#define TRACE6(arg0, arg1, arg2, arg3, arg4, arg5, arg6) OutputDebugStringEx(arg0, arg1, arg2, arg3, arg4, arg5, arg6)
#define TRACE7(arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7) OutputDebugStringEx(arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7)
#else
#define TRACE0(arg0)
#define TRACE1(arg0, arg1)
#define TRACE2(arg0, arg1, arg2)
#define TRACE3(arg0, arg1, arg2, arg3)
#define TRACE4(arg0, arg1, arg2, arg3, arg4)
#define TRACE5(arg0, arg1, arg2, arg3, arg4, arg5)
#define TRACE6(arg0, arg1, arg2, arg3, arg4, arg5, arg6)
#define TRACE7(arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7)
#define TRACETIMESTAMP()
#endif

void OutputDebugStringEx(const char *const pszFormat, ...);

#ifdef _DEBUG
#define ASSERT(e)	\
	{ \
		if (!(e)) \
		{ \
			TRACE4("ASSERTION FAILED: %s in %s, %s: %d\r\n", #e, __PRETTY_FUNCTION__, __FILE__, __LINE__); \
			exit(1); \
		} \
	}
#else
#define ASSERT(e)
#endif
